﻿// <auto-generated> This file has been auto generated by EF Core Power Tools. </auto-generated>
#nullable disable
using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

namespace iLoan.Rules.Models;

public partial class DomainContext : DbContext
{
    public DomainContext()
    {
    }

    public DomainContext(DbContextOptions<DomainContext> options)
        : base(options)
    {
    }

    public virtual DbSet<CoreRule> CoreRules { get; set; }

    public virtual DbSet<CoreRuleCriteriaOperator> CoreRuleCriteriaOperators { get; set; }

    public virtual DbSet<CoreRuleCriterion> CoreRuleCriteria { get; set; }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see https://go.microsoft.com/fwlink/?LinkId=723263.
        => optionsBuilder.UseNpgsql("Persist Security Info=True;Password=8o%2FGjK&A#p^De1;Username=wendell@iloan.nl;Database=iloan-dev-rules;Host=localhost");

    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<CoreRule>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("Core_Rules_pkey");

            entity.ToTable("Core_Rules", "core", tb => tb.HasComment("Rule that can be assessed as part of the application flow"));

            entity.Property(e => e.Id)
                .HasComment("Internal identifier of the rule record")
                .UseIdentityAlwaysColumn()
                .HasColumnName("ID");
            entity.Property(e => e.ApplicantType).HasComment("The type of applicant the rule applies to");
            entity.Property(e => e.Blocked)
                .HasDefaultValue(false)
                .HasComment("Indication if the rule blocks the application");
            entity.Property(e => e.DefaultThreshold).HasComment("Default threshold to apply to the rule");
            entity.Property(e => e.DisplaySection).HasComment("Section in which to display the rule");
            entity.Property(e => e.DutchFilterOnClickthrough).HasComment("The filter to apply when the rule is clicked in the rule summary when the user's language is set to Dutch");
            entity.Property(e => e.DutchRuleExplanation).HasComment("The additional explanation of the rule in Dutch");
            entity.Property(e => e.DutchRuleName)
                .IsRequired()
                .HasComment("The Dutch name of the rule");
            entity.Property(e => e.DutchSuggestedResolution).HasComment("The Dutch explanation on what the suggested resolution is to resolve a review");
            entity.Property(e => e.DutchTriggerReason).HasComment("The Dutch explanation on what the reason is for the triggered review");
            entity.Property(e => e.FilterOnClickthrough).HasComment("The filter to apply when the rule is clicked in the rule summary");
            entity.Property(e => e.RuleExplanation).HasComment("The additional explanation of the rule");
            entity.Property(e => e.RuleName)
                .IsRequired()
                .HasComment("The name of the rule");
            entity.Property(e => e.RunBeforeStatus).HasComment("Specifies the step before which this rule needs to be assessed");
            entity.Property(e => e.Source)
                .IsRequired()
                .HasComment("The source of the rule");
            entity.Property(e => e.SuggestedResolution).HasComment("Explanation on what the suggested resolution is to resolve a review");
            entity.Property(e => e.TriggerReason).HasComment("Explanation on what the reason is for a triggered review");
            entity.Property(e => e.TriggersManualReview)
                .HasDefaultValue(false)
                .HasComment("Indication if the rule triggers a required manual review");
            entity.Property(e => e.Update).HasColumnName("update");
            entity.Property(e => e.UseLastRecord)
                .HasDefaultValue(true)
                .HasComment("Indication if the last record should be used if multiple records exist");
            entity.Property(e => e.WarningField).HasComment("Field to trigger a warning for when the rule gives a fail or review");
        });

        modelBuilder.Entity<CoreRuleCriteriaOperator>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("Core_RuleCriteriaOperator_pkey");

            entity.ToTable("Core_RuleCriteriaOperator", "core", tb => tb.HasComment("A rule criteria operator that specifies how to check multiple criteria for a rule"));

            entity.HasIndex(e => e.RuleId, "Core_RuleCriteriaOperator_RuleID");

            entity.Property(e => e.Id)
                .HasComment("Internal identifier of the rule criteria operator record")
                .UseIdentityAlwaysColumn()
                .HasColumnName("ID");
            entity.Property(e => e.Operator).HasComment("The operator to apply to the rule criteria");
            entity.Property(e => e.RuleId)
                .HasComment("Reference to the rule")
                .HasColumnName("RuleID");

            entity.HasOne(d => d.Rule).WithMany(p => p.CoreRuleCriteriaOperators)
                .HasForeignKey(d => d.RuleId)
                .OnDelete(DeleteBehavior.Cascade)
                .HasConstraintName("Core_RuleCriteriaOperator_RuleID_fkey");
        });

        modelBuilder.Entity<CoreRuleCriterion>(entity =>
        {
            entity.HasKey(e => e.Id).HasName("Core_RuleCriteria_pkey");

            entity.ToTable("Core_RuleCriteria", "core", tb => tb.HasComment("Criteria to assess a rule against"));

            entity.HasIndex(e => e.RuleId, "Core_RuleCriteria_RuleID");

            entity.Property(e => e.Id)
                .HasComment("Internal identifier of the rule criteria record")
                .UseIdentityAlwaysColumn()
                .HasColumnName("ID");
            entity.Property(e => e.Comparison).HasComment("The comparison to use when comparing the property value");
            entity.Property(e => e.IsThresholdCriterium)
                .HasDefaultValue(false)
                .HasComment("Indication if the criterium is overridden by a user defined threshold");
            entity.Property(e => e.Property).HasComment("The property to assess");
            entity.Property(e => e.ReturnCount)
                .HasDefaultValue(false)
                .HasComment("Indication if the value should be a count of matching records");
            entity.Property(e => e.RuleId)
                .HasComment("Reference to the rule")
                .HasColumnName("RuleID");
            entity.Property(e => e.Value).HasComment("The expected property value");
            entity.Property(e => e.ValueIsProperty)
                .HasDefaultValue(false)
                .HasComment("Indication if the value is a reference to another property");

            entity.HasOne(d => d.Rule).WithMany(p => p.CoreRuleCriteria)
                .HasForeignKey(d => d.RuleId)
                .OnDelete(DeleteBehavior.Cascade)
                .HasConstraintName("knockoutcriteria_knockoutid_fkey");
        });

        OnModelCreatingPartial(modelBuilder);
    }

    partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
}